]> git.pld-linux.org Git - packages/rpm.git/blob - rpm.macros
- dropped obsolete comment
[packages/rpm.git] / rpm.macros
1 # $Revision$, $Date$
2 # PLD Linux rpm macros
3
4 %epoch          0
5 %x8664          x86_64 amd64 ia32e
6
7 # kernel compiler
8 %kgcc           %{__cc}
9 %kgcc_package   gcc
10
11 # compiler version
12 %cc_version             %{expand:%%global cc_version %(%{__cc} -dumpversion || echo ERROR)}%cc_version
13 %cxx_version    %{expand:%%global cxx_version %(%{__cxx} -dumpversion || echo ERROR)}%cxx_version
14
15 %__rm                   /bin/rm --interactive=never
16
17 # Build system path macros.
18 #
19 %__autoconf             autoconf %{?debug:-Wall}
20 %__automake             automake -a -c -f --foreign
21 %__autopoint            autopoint --force
22
23 %__gettextize { \
24         if grep -qs 'AM_GNU_GETTEXT.*external' configure.{ac,in} ; then \
25                 gettextize --copy --force --no-changelog; \
26         else \
27                 gettextize --copy --force --no-changelog --intl; \
28         fi; \
29         if [ ! -f po/Makevars ]; then \
30                 cp -f po/Makevars{.template,}; \
31         fi; \
32 }
33
34 %__glib_gettextize      glib-gettextize --copy --force
35 %__gnome_doc_common     gnome-doc-common --copy
36 %__gnome_doc_prepare    gnome-doc-prepare --copy --force
37 %__gtkdocize            gtkdocize --copy
38 %__intltoolize          intltoolize --copy --force
39 %__libtoolize           libtoolize --copy --force --install
40
41 #       Path to top of build area.
42 %_topdir                %{expand:%%global _topdir %(test -d ../SPECS -a -d ../SOURCES && (cd ..; pwd) || echo $HOME/rpm)}%_topdir
43
44 #       The number of cvs changelog entries kept when building package.
45 %_buildchangelogtruncate 20
46
47 %dependencytracking     %{nil}
48
49 #       Relations between package names that cause dependency loops
50 #       with legacy packages that cannot be fixed. Relations are
51 #       specified as
52 #               p>q
53 #       where package p has a Requires: on something that package q Provides:
54 #
55 # XXX   Note: that there cannot be any whitespace within the string "p>q",
56 #       and that both p and q are package names (i.e. no version/release).
57 %_dependency_whiteout   %{nil}
58
59 %_smp_mflags %([ -z "$RPM_BUILD_NCPUS" ] \\\
60         && RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; \\\
61         [ "$RPM_BUILD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")
62
63 #-----------------------------------------------------------------
64 #
65 # (re)definition of %{rpm*flags} with %filterout_* support
66 # BuildRequires:        awk
67 # BuildRequires:        rpmbuild(macros) >= 1.315
68 #
69 # Flags specified in %filterout_* are removed from %rpm*flags, exactly:
70 # %rpmcflags    = %optflags - %filterout - %filterout_c   - %filterout_ld
71 # %rpmcxxflags  = %optflags - %filterout - %filterout_cxx - %filterout_ld
72 # %rpmcppflags  = %optcppflags - %filterout - %filterout_cpp - %filterout_ld
73 # %rpmldflags   = %optldflags - %filterout_ld
74 #
75 # Regular expressions are supported, but to avoid some character be treated
76 # as regular expression it must be escaped twice.
77
78 %filter_out                                             \
79         for (i = 1; i in I; i++) {      A=0;    \
80                 for (f in F) {                          \
81                         if (I[i] ~ "^" F[f] "$") A=1;   \
82                 };                                                      \
83                 if (!A) printf(I[i] FS);        \
84         }
85
86 %rpmcflags %(awk 'BEGIN {
87         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
88         split("%{?filterout} %{?filterout_c} %{?filterout_ld}",F);
89         %{filter_out}
90 }')
91
92 %rpmcxxflags %(awk 'BEGIN {
93         split("%{?debug:%debugcflags}%{!?debug:%optflags}%{?debuginfocflags}",I);
94         split("%{?filterout} %{?filterout_cxx} %{?filterout_ld}",F);
95         %{filter_out}
96 }')
97
98 %rpmcppflags %(awk 'BEGIN {
99         split("%{?debug:%debugcppflags}%{!?debug:%optcppflags}%{?debuginfocppflags}",I);
100         split("%{?filterout} %{?filterout_cpp} %{?filterout_cpp}",F);
101         %{filter_out}
102 }')
103
104 %rpmldflags %(awk 'BEGIN {
105         split("%{?optldflags}",I);
106         split("%{?filterout_ld}",F)
107         %{filter_out}
108 }')
109
110 # rpmldflags with stripped -Wl, -- in the form flags have to be passed to 'ld'
111 # but, don't use it, better use gcc as linker
112 %ld_rpmldflags %(awk 'BEGIN {
113         split("%{rpmldflags}",F);
114         for (f in F) {
115                 s = F[f];
116                 if (s ~ /^-Wl,/) {
117                         s = substr(s,5);
118                         gsub(/,/," ",s);
119                 };
120                 printf(s FS);
121         };
122 }')
123
124 #-----------------------------------------------------------------
125 %configure2_13 { \
126  if [ -n "$LINGUAS" ]; then unset LINGUAS; fi; \
127  LDFLAGS="${LDFLAGS:-%rpmldflags}" ; export LDFLAGS ; \
128  CFLAGS="${CFLAGS:-%rpmcflags}" ; export CFLAGS ; \
129  CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" ; export CXXFLAGS ; \
130  FFLAGS="${FFLAGS:-%rpmcflags}" ; export FFLAGS ; \
131  FCFLAGS="${FCFLAGS:-%rpmcflags}" ; export FCFLAGS ; \
132  CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" ; export CPPFLAGS ; \
133  %{?__cc:CC="%{__cc}" ; export CC ; } \
134  %{?__cxx:CXX="%{__cxx}" ; export CXX ; } \
135  %{?configuredir:%{configuredir}}%{!?configuredir:.}/configure \
136         --host=%{_target_platform} \
137         --prefix=%{_prefix} \
138         --exec-prefix=%{_exec_prefix} \
139         --bindir=%{_bindir} \
140         --sbindir=%{_sbindir} \
141         --sysconfdir=%{_sysconfdir} \
142         --datadir=%{_datadir} \
143         --includedir=%{_includedir} \
144         --libdir=%{_libdir} \
145         --libexecdir=%{_libexecdir} \
146         --localstatedir=%{_localstatedir} \
147         --sharedstatedir=%{_sharedstatedir} \
148         --mandir=%{_mandir} \
149         --infodir=%{_infodir} \
150         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
151         %{dependencytracking} \
152 }
153
154 # override __cmake to add -j4 in your ~/.rpmmacros for parallel make
155 %__cmake        /usr/bin/cmake
156 %cmake { \
157 CC="%{__cc}" \
158 CXX="%{__cxx}" \
159 CFLAGS="%{rpmcflags}" \
160 CXXFLAGS="%{rpmcxxflags}" \
161 %{__cmake} \
162 }
163
164 # override __scons to add -j4 in your ~/.rpmmacros for parallel make
165 %__scons        /usr/bin/scons
166 %scons { \
167 %{__scons} \
168         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
169         CFLAGS="${CFLAGS:-%rpmcflags}" \
170         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
171         FFLAGS="${FFLAGS:-%rpmcflags}" \
172         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
173         %{?__cc:CC="%{__cc}"} \
174         %{?__cxx:CXX="%{__cxx}"} \
175         libsuffix=%{_lib} \
176         prefix=%{_prefix} \
177 }
178
179 # waf. see waf.spec
180 # override __waf to add -j4 in your ~/.rpmmacros for parallel make
181 %__waf  /usr/bin/waf
182 %waf { \
183 CC="%{__cc}" \
184 CXX="%{__cxx}" \
185 CPP="%{__cpp}" \
186 CFLAGS="%{rpmcflags}" \
187 CXXFLAGS="%{rpmcxxflags}" \
188 %{__waf} \
189 }
190
191 #----------------------------------------------------------------
192 #%configure_cache 0
193 %configure_cache_file   %{buildroot}.configure.cache
194
195 %configure {./configure \
196         LDFLAGS="${LDFLAGS:-%rpmldflags}" \
197         CFLAGS="${CFLAGS:-%rpmcflags}" \
198         CXXFLAGS="${CXXFLAGS:-%rpmcxxflags}" \
199         FFLAGS="${FFLAGS:-%rpmcflags}" \
200         FCFLAGS="${FCFLAGS:-%rpmcflags}" \
201         CPPFLAGS="${CPPFLAGS:-%rpmcppflags}" \
202         %{?__cc:CC="%{__cc}"} \
203         %{?__cxx:CXX="%{__cxx}"} \
204         --host=%{_target_platform} \
205         --build=%{_target_platform} \
206         --prefix=%{_prefix} \
207         --exec-prefix=%{_exec_prefix} \
208         --bindir=%{_bindir} \
209         --sbindir=%{_sbindir} \
210         --sysconfdir=%{_sysconfdir} \
211         --datadir=%{_datadir} \
212         --includedir=%{_includedir} \
213         --libdir=%{_libdir} \
214         --libexecdir=%{_libexecdir} \
215         --localstatedir=%{_localstatedir} \
216         --sharedstatedir=%{_sharedstatedir} \
217         --mandir=%{_mandir} \
218         --infodir=%{_infodir} \
219         --x-libraries=%{?_x_libraries}%{!?_x_libraries:%{_libdir}} \
220         %{dependencytracking} \
221         %{?configure_cache:--cache-file=%{configure_cache_file}} \
222 }
223
224 # overload to insert debuginfo package
225 %prep \
226 %if 0%{?_enable_debug_packages}\
227 %{debug_package}\
228 %endif\
229 %%prep\
230 %{nil}
231
232 # Location of autoconf macros
233 %_aclocaldir    %{expand:%%global _aclocaldir %(aclocal --print-ac-dir || echo ERROR)}%_aclocaldir
234
235 # Location of omf files
236 %_omf_dest_dir  %{expand:%%global _omf_dest_dir %(scrollkeeper-config --omfdir || echo ERROR)}%_omf_dest_dir
237
238 # Location of pkgconfig files
239 %_pkgconfigdir  /usr/%{_lib}/pkgconfig
240 # noarch pkgconfig files
241 %_npkgconfigdir /usr/share/pkgconfig
242
243 # Location of desktop files
244 %_desktopdir    /usr/share/applications
245 %_applnkdir     ERROR:_applnkdir_is_obsolete_use_desktopdir_instead
246
247 # Location of pixmaps for applnk/desktop files
248 %_pixmapsdir    /usr/share/pixmaps
249
250 # Location of themable icons for applnk/desktop files
251 %_iconsdir      /usr/share/icons
252
253 # Location of fonts directories
254 %_fontsdir      /usr/share/fonts
255
256 # Location of Gtk and associated libraries documentation
257 %_gtkdocdir     %{_defaultdocdir}/gtk-doc/html
258
259 # Location of KDE documentation
260 %_kdedocdir     %{_defaultdocdir}/kde/HTML
261
262 # unsermake script
263 %__unsermake /usr/share/unsermake/unsermake
264
265 # Current date
266 %date           %(LC_ALL="C" date +"%a %b %d %Y")
267
268 # Example files, programs, scripts...
269 %_examplesdir   /usr/src/examples
270
271 # Alternative kernel type/version
272 %_alt_kernel    %{nil}%{?alt_kernel:-%{?alt_kernel}}
273
274 # The directory holding Linux kernel sources
275 %_kernelsrcdir  /usr/src/linux%{_alt_kernel}
276
277 # If non-empty "debug" macro defined, add "dbg" suffix to release number
278 %_rpmfilename           %%{NAME}-%%{VERSION}-%%{RELEASE}%{?debug:dbg}.%%{ARCH}.rpm
279
280 # Requires name = version-release
281 %requires_releq()               %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}-%{R}\\n' | grep -v 'is not')
282
283 %releq_kernel                   %{expand:%%global releq_kernel %(R=$(LC_ALL=C rpm -q --qf '%{N} = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel
284 %releq_kernel_up                %{expand:%%global releq_kernel_up %(R=$(LC_ALL=C rpm -q --qf '%{N}-up = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_up
285 %releq_kernel_smp()             %{expand:%%global releq_kernel_smp %(R=$(LC_ALL=C rpm -q --qf '%{N}-smp = %|E?{%{E}:}|%{V}-%{R}' -f %{_kernelsrcdir}/include/linux/version.h 2>/dev/null | grep -v 'is not' | sed -e 's:-headers::;s:-config::'); echo ${R:-ERROR})}%releq_kernel_smp
286 %requires_releq_kernel(s:)              Requires%{-s:(%{-s*})}: %releq_kernel
287 %requires_releq_kernel_up(s:)   Requires%{-s:(%{-s*})}: %releq_kernel_up
288 %requires_releq_kernel_smp(s:)  Requires%{-s:(%{-s*})}: %releq_kernel_smp
289
290 # XXX: why epoch 0 is stripped?
291 %requires_eq()          %(echo '%*' | LC_ALL="C" xargs -r rpm -q --qf 'Requires: %{N} = %|E?{%{E}:}|%{V}\\n' | sed -e 's/ 0:/ /' | grep -v 'is not')
292 %requires_eq_to() %(LC_ALL="C" rpm -q --qf 'Requires: %1 = %|E?{%{E}:}|%{V}' %2 | grep -v "is not")
293
294 %apache_modules_api %{expand:%%global apache_modules_api %(awk '/#define MODULE_MAGIC_NUMBER_MAJOR/ {print $3}' /usr/include/apache/ap_mmn.h 2>/dev/null || echo ERROR)}%apache_modules_api
295
296 # kernel version-release handling
297 %__kernel_ver    %{expand:%%global __kernel_ver %( \\
298         Z=$(awk -F'"' '/UTS_RELEASE/{print $2}' %{_kernelsrcdir}/include/linux/{version,utsrelease}.h 2>/dev/null); \\
299         Z=${Z:-$(awk -F' = ' '/^VERSION/{v=$2} /^PATCHLEVEL/{p=$2} /^SUBLEVEL/{s=$2} /^EXTRAVERSION/{e=$2} END {printf("%d.%d.%d%s", v, p, s, e)}' %{_kernelsrcdir}/Makefile 2>/dev/null)}; \\
300         echo ${Z:-ERROR}; \\
301 )}%__kernel_ver
302
303 %__kernel_rel   %{expand:%%global __kernel_rel %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rel
304 %__kernel_rpmvr %{expand:%%global __kernel_rpmvr %(Z=$(LC_ALL=C rpm -qf %{_kernelsrcdir}/include/linux/fs.h 2>/dev/null --qf "%{V}-%{R}" | grep -v "is not"); echo ${Z:-ERROR})}%__kernel_rpmvr
305 %_kernel_ver    %{expand:%%global _kernel_ver %{__kernel_ver}%{?with_dist_kernel:%(echo %{__kernel_ver} | grep -q -e - || echo -%{__kernel_rel})}}%_kernel_ver
306 %_kernel_ver_str %{expand:%%global _kernel_ver_str %(echo %{!?_without_dist_kernel:%{__kernel_rpmvr}}%{?_without_dist_kernel:%{__kernel_ver}} | sed -e 's/-/_/g')}%_kernel_ver_str
307
308 # `uname -r` to be used in @release field
309 %_kernel_vermagic       %{expand:%%global _kernel_vermagic %(echo %{_kernel_ver} | sed -e 's/-/_/g')}%_kernel_vermagic
310
311 # sgml macros
312 %xmlcat_add()           /usr/bin/xmlcatalog --noout --add nextCatalog \"\" %1 /etc/xml/catalog ;
313 %xmlcat_del()           /usr/bin/xmlcatalog --noout --del %1 /etc/xml/catalog ;
314 %xmlcat_add_rewrite     /usr/bin/xmlcatalog --noout --add rewriteSystem
315 %xmlcat_create()        /usr/bin/xmlcatalog --noout --create %1 ;
316 %sgmlcat_add()          /usr/bin/install-catalog --add %1 %2 > /dev/null ;
317 %sgmlcat_del()          /usr/bin/install-catalog --remove %1 %2 > /dev/null ;
318 %docbook_sgmlcat_fix() { for l in \
319 '' \
320 '  -- default decl --' \
321 'DTDDECL "-//OASIS//DTD DocBook XML V%2//EN" "../../xml.dcl"' \
322 '  -- hacks for opensp --' \
323 'SYSTEM "file://%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd" "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
324 'SYSTEM "http://www.oasis-open.org/docbook/xml/%2/docbookx.dtd"                  "%{_datadir}/sgml/docbook/xml-dtd-%2/docbookx.dtd"' \
325 '' \
326 ; do echo $l; done >> %1 \
327 }
328
329 # vim - "
330
331 # minimum file size needed for compressed documents.
332 # just smaller files than this get larger when compressed.
333 # some stats:
334 # - 0 byte file compressed was 25 bytes .gz
335 # - 39 byte file was compressed as 57
336 # - with test/test.spec@man 158 byte file was compressed also 158
337 %_min_compress_bytes    159
338
339 #-----------------------------------------------------------------
340 # find and gzip all files in %{_mandir} and %{infodir}
341 #
342 # Requires: xargs, find
343 #
344 #%no_install_post_compress_docs 1
345 %__spec_install_post_compress_docs { \
346 %{!?no_install_post_compress_docs:__spec_install_post_compress_docs() { \
347         for i in /usr/share/man /usr/X11R6/man; do \
348                 if [ -d "$RPM_BUILD_ROOT$i" ]; then \
349                         echo "Compress man pages: $i"; \
350                         find "$RPM_BUILD_ROOT$i" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
351                         find "$RPM_BUILD_ROOT$i" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
352                         find $RPM_BUILD_ROOT$i -type l | while read a; do \
353                                 m=$(readlink $a); \
354                                 rm -f $a; \
355                                 echo .so ${m##*/} > $a; \
356                                 echo >&2 "Converted ${a#$RPM_BUILD_ROOT} from symlink to man link: ${m##*/}"; \
357                         done; \
358                         find "$RPM_BUILD_ROOT$i" -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
359                 fi; \
360         done; \
361         if [ -d "$RPM_BUILD_ROOT%{_infodir}" ]; then \
362                 echo "Compress info pages: %{_infodir}"; \
363                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.bz2' -print | xargs -r %{__bzip2} -df; \
364                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.gz' -print | xargs -r %{__gzip} -dnf; \
365                 find "$RPM_BUILD_ROOT%{_infodir}" -name '*.info*' -type f -size +%{_min_compress_bytes}c -print | xargs -r %{__gzip} -9nf; \
366         fi; \
367 }; __spec_install_post_compress_docs } }
368
369 #-----------------------------------------------------------------
370 # Strip executable binaries and shared object files
371 #
372 # Requires: find, awk, strip, cut, xargs
373 #
374 # Special macros which affect this process:
375 #%no_install_post_strip 1               # disable stripping at all
376 #%_noautostrip                  regexp  # exclude files matching (anchored!) regex from stripping
377 #%_autostripall                 regexp  # strip files matching (anchored!) regex using plain strip
378 #%_autostripunneeded    regexp  # strip files matching (anchored!) regex using strip --strip-unneeded
379 #%_autostripdebug               regexp  # strip files matching (anchored!) regex using strip --strip-debug
380 #
381 %__spec_install_post_strip {%{!?debug: \
382 %{!?no_install_post_strip:__spec_install_post_strip() { \
383 if [ -d "$RPM_BUILD_ROOT" ]; then \
384         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
385                 modulelist=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
386                 if [ "$modulelist" ]; then \
387                         modulecount=$(echo "$modulelist" | wc -l); \
388                         printf "Stripping %d kernel modules..." $modulecount; \
389                         echo "$modulelist" | xargs -l512 chmod u+w; \
390                         echo "$modulelist" | xargs -l512 %{__strip} --strip-unneeded --remove-section=.comment --remove-section=.note.GNU-stack; \
391                         echo "DONE"; \
392                 fi; \
393         fi; \
394         filelist=$(find $RPM_BUILD_ROOT -type f ! -regex ".*/usr/lib[0-9]*/debug/.*\.debug" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautostrip:! -regex "%{_noautostrip}"} %{?_autostripall:! -regex "%{_autostripall}"} %{?_autostripunneeded:! -regex "%{_autostripunneeded}"} %{?_autostripdebug:! -regex "%{_autostripdebug}"}); \
395         if [ -n "$filelist" ]; then \
396                 filetypes=`echo "$filelist" | xargs -r -d'\\n' file`; \
397                 elfexelist=`echo "$filetypes" | awk -F: '/ELF.*executable/ {print $1}'`; \
398                 elfsharedlist=`echo "$filetypes" | awk -F: '/LF.*shared object/ {print $1}'`; \
399                 archiveslist=`echo "$filetypes" | awk -F: '/current ar archive/ {print $1}'`; \
400                 if [ -n "$elfexelist" ]; then \
401                         printf "Stripping %d ELF executables..." $(echo "$elfexelist" | wc -l); \
402                         chmod u+w $elfexelist; \
403                         %{__strip} --remove-section=.note --remove-section=.comment $elfexelist; \
404                         echo "DONE"; \
405                 fi; \
406                 if [ -n "$elfsharedlist" ]; then \
407                         printf "Stripping %d ELF shared libraries..." $(echo "$elfsharedlist" | wc -l); \
408                         chmod u+w $elfsharedlist; \
409                         %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $elfsharedlist; \
410                         echo "DONE"; \
411                 fi; \
412                 if [ -n "$archiveslist" ]; then \
413                         printf "Stripping %d ar archives..." $(echo "$archiveslist" | wc -l); \
414                         chmod u+w $archiveslist; \
415                         %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $archiveslist; \
416                         echo "DONE"; \
417                 fi; \
418         fi; \
419     filelist_all=%{?_autostripall:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripall}")}; \
420     filelist_unneeded=%{?_autostripunneeded:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripunneeded}")}; \
421     filelist_debug=%{?_autostripdebug:$(find $RPM_BUILD_ROOT -type f -regex "%{_autostripdebug}")}; \
422         if [ -n "$filelist_all" ]; then \
423                 printf "Stripping everything from %d additional files..." $(echo "$filelist_all" | wc -l); \
424                 chmod u+w $filelist_all; \
425                 %{__strip} --remove-section=.note --remove-section=.comment $filelist_all; \
426                 echo "DONE"; \
427         fi; \
428         if [ -n "$filelist_unneeded" ]; then \
429                 printf "Stripping unneeded from %d additional files..." $(echo "$filelist_unneeded" | wc -l); \
430                 chmod u+w $filelist_unneeded; \
431                 %{__strip} --strip-unneeded --remove-section=.note --remove-section=.comment $filelist_unneeded; \
432                 echo "DONE"; \
433         fi; \
434         if [ -n "$filelist_debug" ]; then \
435                 printf "Stripping debuginfo from %d additional files..." $(echo "$filelist_debug" | wc -l); \
436                 chmod u+w $filelist_debug; \
437                 %{__strip} --strip-debug --remove-section=.note --remove-section=.comment $filelist_debug; \
438                 echo "DONE"; \
439         fi; \
440 fi; }; __spec_install_post_strip } } }
441
442 #-----------------------------------------------------------------
443 # remove all RPATH from executable binaries and shared object files
444 #
445 # Requires: find, awk, cut, xargs, chrpath, uname
446 #
447 # Special macros which affect this process
448 #%no_install_post_chrpath       1       # disable chrpath at all
449 #%_noautochrpath        regex           # exclude files matching (anchored!) regex from chrpath
450 #
451 %__spec_install_post_chrpath {%{!?debug: \
452 %{!?no_install_post_chrpath: __spec_install_post_chrpath() { \
453 if [ -d "$RPM_BUILD_ROOT" ]; then \
454         files=`find $RPM_BUILD_ROOT -type f ! -regex ".*ld-[0-9.]*so.*" ! -regex ".*/usr/lib[0-9]*/debug/.*" ! -regex ".*/lib/modules/.*" ! -regex ".*%{_docdir}/.*" ! -regex ".*%{_includedir}/.*" %{?_noautochrpath:! -regex "%{_noautochrpath}"}`; \
455         if [ -n "$files" ]; then \
456                 objs=`echo "$files" | xargs -r -d'\\n' file | awk -F: '/ELF.*(executable.*dynamically linked|shared object)/ {print $1}'`; \
457         fi; \
458         if [ -n "$objs" ]; then \
459                 printf "Remove RPATH from %d executable binaries and shared object files.\n" $(echo "$objs" | wc -l); \
460                 echo "$objs" | \
461                 while read file; do \
462                         rpath= ; \
463                         chmod u+w "$file"; \
464                         for dir in $(chrpath -l "$file" | awk '/RPATH=/ { gsub(/.*RPATH=/,""); gsub(/:/," "); print $0 }'); do \
465                                         case $dir in \
466                                         '$ORIGIN' ) \
467                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
468                                                 else rpath="$rpath:$dir" ; fi ; \
469                                                 continue ; \
470                                                 ;; \
471                                         esac ; \
472                                         newdir=$(readlink -m "$dir"); \
473                                         [ ${#newdir} -le ${#dir} ] && dir=$newdir; \
474                                         case $dir in \
475                                         /home/* | /tmp/* | /usr/lib | /usr/lib64 | /lib | /lib64 | /usr/local/lib | /usr/local/lib64 | /usr/X11R6/lib | /usr/X11R6/lib64 ) \
476                                                 echo "remove-rpath: $dir in $file"; \
477                                                 ;; \
478                                         * ) \
479                                                 if [ "$rpath" = "" ] ; then rpath="$dir" ; \
480                                                 else rpath="$rpath:$dir" ; fi ; \
481                                                 ;; \
482                                         esac ; \
483                         done ; \
484                         if [ "$rpath" = "" ] ; then chrpath -d "$file" > /dev/null ; \
485                         else chrpath -r "$rpath" "$file" > /dev/null ; fi ; \
486                 done; \
487         fi; \
488 fi; }; __spec_install_post_chrpath } } }
489
490 #-----------------------------------------------------------------
491 # Find and gzip all kernel modules
492 #
493 # Requires: find
494 #
495 #%no_install_post_compress_modules      1
496 %__spec_install_post_compress_modules { \
497 %{!?no_install_post_compress_modules: __spec_install_post_compress_modules() { \
498         if [ -d $RPM_BUILD_ROOT/lib/modules ]; then \
499                 q=$(find $RPM_BUILD_ROOT/lib/modules -name '*o' -type f -print); \
500                 if [ "$q" ]; then \
501                         printf "Compress %d kernel modules..." $(echo "$q" | wc -l); \
502                         echo "$q" | xargs -r %{__gzip} -9nf; \
503                         echo "DONE"; \
504                         find $RPM_BUILD_ROOT/lib/modules -name '*o' -type l -printf "%p %l\n" | \
505                         while read a b; do ln -sf $b.gz $a.gz; rm -f $a; done; \
506                 fi; \
507         fi; \
508 }; __spec_install_post_compress_modules } }
509
510 # Remove common Perl files we don't package
511 %__spec_install_post_perl_clean {\
512 %{!?no_install_post_perl_clean: \
513 %{?pdir:rm -f $RPM_BUILD_ROOT{%{perl_archlib}/perllocal.pod,%{perl_vendorarch}/auto/%{pdir}%{?pnam:/%(echo %{pnam} | tr - /)}/.packlist}} \
514 } }
515
516 #-----------------------------------------------------------------
517 # Update GConf2 schemas
518 #
519 # Requires: GConf2
520 #
521 %gconf_schema_install() \
522         umask 022; \
523         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-install-rule /etc/gconf/schemas/%{?1}%{!?1:*.schemas} > /dev/null; \
524 %{nil}
525
526 %gconf_schema_uninstall() \
527 if [ $1 = 0 ]; then \
528         umask 022; \
529         GCONF_CONFIG_SOURCE="xml:readwrite:/etc/gconf/gconf.xml.defaults" /usr/bin/gconftool-2 --makefile-uninstall-rule /etc/gconf/schemas/%{?1} > /dev/null \
530 fi; \
531 %{nil}
532
533 #-----------------------------------------------------------------
534 # Update desktop MIME database
535 # requires: desktop-file-utils
536 %update_desktop_database() {{ \
537         umask 022; \
538         /usr/bin/update-desktop-database -q; \
539 }}%{nil}
540
541 %update_desktop_database_post %update_desktop_database
542
543 %update_desktop_database_postun() {{ \
544 if [ "$1" = "0" ]; then \
545         %update_desktop_database; \
546 fi; \
547 }}%{nil}
548
549 #-----------------------------------------------------------------
550 # Update shared MIME info database
551 # requires: shared-mime-info
552 #
553 %update_mime_database() {{ \
554         umask 022; \
555         /usr/bin/update-mime-database %{_datadir}/mime; \
556 }}%{nil}
557
558 #-----------------------------------------------------------------
559 # Update icon cache
560 # requires: gtk+
561 #
562 %update_icon_cache() {{ \
563         umask 022; \
564         /usr/bin/gtk-update-icon-cache -qf %{_datadir}/icons/%1; \
565 }}%{nil}
566
567 #-----------------------------------------------------------------
568 # Update scrollkeeper database
569 # requires: scrollkeeper
570 #
571 %scrollkeeper_update_post() \
572         /usr/bin/scrollkeeper-update -q; \
573 %{nil}
574
575 %scrollkeeper_update_postun() \
576 if [ "$1" = "0" ]; then \
577         /usr/bin/scrollkeeper-update -q; \
578 fi; \
579 %{nil}
580
581 #-----------------------------------------------------------------
582 # post %install sequence:
583 # - autodeps exceptions
584 # - compress all man and info pages,
585 # - strip all ELF executables and ELF shared objects if not %debug.
586 # - compress kernel modules if any
587
588 ###################################################################
589 # Requires/Provides automation
590 # exceptions system by Jacek Konieczny <jajcus@pld-linux.org>
591 #
592 %__noautoreqfiles       %(sed -e s'/#.*//' /etc/rpm/noautoreqfiles)%{?_noautoreqfiles: %{_noautoreqfiles}}
593 %__noautoprovfiles      %(sed -e s'/#.*//' /etc/rpm/noautoprovfiles)%{?_noautoprovfiles: %{_noautoprovfiles}}
594 %__noautoreq            %(sed -e s'/#.*//' /etc/rpm/noautoreq)%{?_noautoreq: %{_noautoreq}}
595 %__noautoreqdep         %(sed -e s'/#.*//' /etc/rpm/noautoreqdep)%{?_noautoreqdep: %{_noautoreqdep}}
596 %__noautoprov           %(sed -e s'/#.*//' /etc/rpm/noautoprov)%{?_noautoprov: %{_noautoprov}}
597
598 #%_noautocompressdoc    %{nil}
599 #
600 %_missing_doc_files_terminate_build     1%{nil}
601 %_unpackaged_files_terminate_build      %{nil}
602 # (X)emacs support
603 %___emacs_lispdir_helper  -batch -q -eval '(while load-path (princ (concat (car load-path) "\\n")) (setq load-path (cdr load-path)))' 2> /dev/null|sed -n '/\\(.*\\/x\\?emacs\\/site-lisp\\)\\/\\?$/{s,,\\1,p;q;}'
604 %_emacs_lispdir %{expand:%%global _emacs_lispdir %(Z=$(emacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_emacs_lispdir
605 %_xemacs_lispdir %{expand:%%global _xemacs_lispdir %(Z=$(xemacs %___emacs_lispdir_helper); echo ${Z:-ERROR})}%_xemacs_lispdir
606
607 %__php_provides %{nil}
608 %__php_requires %{nil}
609 %__perl_provides %{nil}
610 %__perl_requires %{nil}
611 %__mono_provides %{nil}
612 %__mono_requires %{nil}
613
614 # Perl specific macro definitions.
615 %perl_privlib           %{expand:%%global perl_privlib %(eval $(%{__perl} -V:installprivlib 2>/dev/null); echo ${installprivlib:-ERROR})}%perl_privlib
616 %perl_archlib           %{expand:%%global perl_archlib %(eval $(%{__perl} -V:installarchlib 2>/dev/null); echo ${installarchlib:-ERROR})}%perl_archlib
617 %perl_vendorlib         %{expand:%%global perl_vendorlib %(eval $(%{__perl} -V:installvendorlib 2>/dev/null); echo ${installvendorlib:-ERROR})}%perl_vendorlib
618 %perl_vendorarch        %{expand:%%global perl_vendorarch %(eval $(%{__perl} -V:installvendorarch 2>/dev/null); echo ${installvendorarch:-ERROR})}%perl_vendorarch
619 %perl_sitelib           %{expand:%%global perl_sitelib %(eval $(%{__perl} -V:installsitelib 2>/dev/null); echo ${installsitelib:-ERROR})}%perl_sitelib
620 %perl_sitearch          %{expand:%%global perl_sitearch %(eval $(%{__perl} -V:installsitearch 2>/dev/null); echo ${installsitearch:-ERROR})}%perl_sitearch
621
622 # Ruby
623 %__ruby                         /usr/bin/ruby
624 %ruby_archdir           %{expand:%%global ruby_archdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["archdir"]' 2>/dev/null || echo ERROR)}%ruby_archdir
625 %ruby_ridir                     %{expand:%%global ruby_ridir %(%{__ruby} -r rbconfig -e 'include Config; print File.join(CONFIG["datadir"], "ri", CONFIG["ruby_version"], "system")' 2>/dev/null || echo ERROR)}%ruby_ridir
626 %ruby_rubylibdir        %{expand:%%global ruby_rubylibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["rubylibdir"]' 2>/dev/null || echo ERROR)}%ruby_rubylibdir
627 %ruby_vendorarchdir     %{expand:%%global ruby_vendorarchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorarchdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorarchdir
628 %ruby_vendorlibdir      %{expand:%%global ruby_vendorlibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["vendorlibdir"]' 2>/dev/null || echo ERROR)}%ruby_vendorlibdir
629 %ruby_sitearchdir       %{expand:%%global ruby_sitearchdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitearchdir"]' 2>/dev/null || echo ERROR)}%ruby_sitearchdir
630 %ruby_sitelibdir        %{expand:%%global ruby_sitelibdir %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["sitelibdir"]' 2>/dev/null || echo ERROR)}%ruby_sitelibdir
631 %ruby_version           %{expand:%%global ruby_version %(%{__ruby} -r rbconfig -e 'print Config::CONFIG["ruby_version"]' 2>/dev/null || echo ERROR)}%ruby_version
632 %ruby_ver_requires_eq   Requires:       ruby(ver) = %ruby_version
633 %ruby_mod_ver_requires_eq       Requires:       ruby-modules(ver) = %ruby_version
634
635 %php_pear_dir           /usr/share/pear
636 %php_data_dir           /usr/share/php
637 %php_extensiondir       %{expand:%%global php_extensiondir %(php-config --extension-dir 2>/dev/null || echo ERROR)}%php_extensiondir
638 %php_sysconfdir         %{expand:%%global php_sysconfdir %(php-config --sysconfdir 2>/dev/null || echo ERROR)}%php_sysconfdir
639 %php_includedir         %{expand:%%global php_includedir %(php-config --include-dir 2>/dev/null || echo ERROR)}%php_includedir
640
641 # extract php/zend api versions
642 %php_major_version              %{expand:%%global php_major_version %(awk '/#define PHP_MAJOR_VERSION/{print $3}' %{php_includedir}/main/php_version.h 2>/dev/null || echo ERROR)}%php_major_version
643 %php_api_version                %{expand:%%global php_api_version %(awk '/#define PHP_API_VERSION/{print $3}' %{php_includedir}/main/php.h 2>/dev/null || echo ERROR)}%php_api_version
644 %php_pdo_api_version    %{expand:%%global php_pdo_api_version %(awk '/#define PDO_DRIVER_API/{print $3}' %{php_includedir}/ext/pdo/php_pdo_driver.h 2>/dev/null || echo ERROR)}%php_pdo_api_version
645 %php_debug                              %{expand:%%global php_debug %(awk '/#define ZEND_DEBUG/{print $3}' %{php_includedir}/main/php_config.h 2>/dev/null || echo ERROR)}%php_debug
646 %zend_module_api                %{expand:%%global zend_module_api %(awk '/#define ZEND_MODULE_API_NO/{print $3}' %{php_includedir}/Zend/zend_modules.h 2>/dev/null || echo ERROR)}%zend_module_api
647 %zend_extension_api             %{expand:%%global zend_extension_api %(awk '/#define ZEND_EXTENSION_API_NO/{print $3}' %{php_includedir}/Zend/zend_extensions.h 2>/dev/null || echo ERROR)}%zend_extension_api
648 %zend_zts                               %{expand:%%global zend_zts %(Z=$(grep -sc '^#define ZTS 1' %{php_includedir}/main/php_config.h); echo ${Z:-ERROR})}%zend_zts
649
650 # helper macro
651 %__php_api_requires(v:) Requires: php%{-v*}(%{expand:%1}) = %{expand:%{%{!?2:%{1}}%{?2}}}
652
653 # macros for public use
654 # for php extensions (php-pecl)
655 %requires_php_extension %{__php_api_requires modules_api php_api_version} \
656 %{__php_api_requires zend_module_api} \
657 %{__php_api_requires -v %php_major_version debug php_debug} \
658 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
659
660 # for zend extensions
661 %requires_zend_extension %{__php_api_requires zend_module_api} \
662 %{__php_api_requires zend_extension_api} \
663 %{__php_api_requires -v %php_major_version debug php_debug} \
664 %{__php_api_requires -v %php_major_version thread-safety zend_zts}
665
666 # for php pdo modules (php-pecl-PDO_*)
667 %requires_php_pdo_module %{__php_api_requires PDO_API php_pdo_api_version}
668
669 # for using PHP post scripts. for PHP >= 5.0
670 %php_webserver_restart \
671 [ ! -f /etc/apache/conf.d/??_mod_php.conf ] || %service -q apache restart \
672 [ ! -f /etc/httpd/conf.d/??_mod_php.conf ] || %service -q httpd restart \
673 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
674         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
675         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php.fcgi* ]]; then \
676                 %service -q php-fcgi restart \
677         fi \
678 fi \
679 %{nil}
680
681 # for using php post scripts. for PHP >= 4.0 && PHP < 5.0
682 %php4_webserver_restart \
683 [ ! -f /etc/apache/conf.d/??_mod_php4.conf ] || %service -q apache restart \
684 [ ! -f /etc/httpd/conf.d/??_mod_php4.conf ] || %service -q httpd restart \
685 if [ -f /etc/rc.d/init.d/php-fcgi ]; then \
686         PHP_FCGI_BINARY=; . /etc/sysconfig/php-fcgi 2>/dev/null \
687         if [[ ${PHP_FCGI_BINARY:-php.fcgi} = *php4.fcgi* ]]; then \
688                 %service -q php-fcgi restart \
689         fi \
690 fi \
691 %{nil}
692
693 # X.org helper macros
694 %__xorg_abi_requires_ge() Requires: xorg-xserver-server(%{expand:%1}-abi) >= %{expand:%{%2}}
695 %__xorg_abi_requires_lt() Requires: xorg-xserver-server(%{expand:%1}-abi) < %(awk -vv=%{expand:%{%2}} 'BEGIN{split(v, a, "."); printf("%s.0", a[1] + 1); exit}')
696
697 %xorg_xserver_ansic_abi         %{expand:%%global xorg_xserver_ansic_abi %(awk '/#define ABI_ANSIC_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_ansic_abi
698 %xorg_xserver_extension_abi     %{expand:%%global xorg_xserver_extension_abi %(awk '/#define ABI_EXTENSION_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_extension_abi
699 %xorg_xserver_font_abi          %{expand:%%global xorg_xserver_font_abi %(awk '/#define ABI_FONT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null | echo ERROR)}%xorg_xserver_font_abi
700 %xorg_xserver_videodrv_abi      %{expand:%%global xorg_xserver_videodrv_abi %(awk '/#define ABI_VIDEODRV_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_videodrv_abi
701 %xorg_xserver_xinput_abi        %{expand:%%global xorg_xserver_xinput_abi %(awk '/#define ABI_XINPUT_VERSION/ { split($0,A,/[(,)]/); printf("%d.%d",A[2], A[3]); }' /usr/include/xorg/xf86Module.h 2> /dev/null || echo ERROR)}%xorg_xserver_xinput_abi
702
703 %requires_xorg_xserver_extension \
704 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
705 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
706 %{__xorg_abi_requires_ge extension xorg_xserver_extension_abi} \
707 %{__xorg_abi_requires_lt extension xorg_xserver_extension_abi} \
708 %{nil}
709
710 %requires_xorg_xserver_xinput \
711 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
712 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
713 %{__xorg_abi_requires_ge xinput xorg_xserver_xinput_abi} \
714 %{__xorg_abi_requires_lt xinput xorg_xserver_xinput_abi} \
715 %{nil}
716
717 %requires_xorg_xserver_font \
718 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
719 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
720 %{__xorg_abi_requires_ge font xorg_xserver_font_abi} \
721 %{__xorg_abi_requires_lt font xorg_xserver_font_abi} \
722 %{nil}
723
724 %requires_xorg_xserver_videodrv \
725 %{__xorg_abi_requires_ge ansic xorg_xserver_ansic_abi} \
726 %{__xorg_abi_requires_lt ansic xorg_xserver_ansic_abi} \
727 %{__xorg_abi_requires_ge videodrv xorg_xserver_videodrv_abi} \
728 %{__xorg_abi_requires_lt videodrv xorg_xserver_videodrv_abi} \
729 %{nil}
730
731 # Python specific macro definitions.
732 # python main version
733 %py_ver                 %{expand:%%global py_ver %(%{__python} -c "import sys; print sys.version[:3]" 2>/dev/null || echo ERROR)}%py_ver
734
735 # directories
736 %py_prefix              %{expand:%%global py_prefix %(%{__python} -c "import sys; print sys.prefix" 2>/dev/null || echo ERROR)}%py_prefix
737 %py_libdir              %{py_prefix}/%{_lib}/python%{py_ver}
738 %py_scriptdir   %{py_prefix}/share/python%{py_ver}
739 %py_incdir              /usr/include/python%{py_ver}
740 %py_sitedir             %{py_libdir}/site-packages
741 %py_sitescriptdir %{py_scriptdir}/site-packages
742 %py_dyndir              %{py_libdir}/lib-dynload
743
744 # pure python modules compilation
745 %py_comp                python -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
746
747 %py_ocomp               python -O -c "import compileall; import sys; compileall.compile_dir(sys.argv[1], ddir=sys.argv[1][len('$RPM_BUILD_ROOT'):])"
748
749 # Software written in Python language require Python with main version
750 %pyrequires_eq() Requires:      %1
751
752 # Hardlink binary identical .pyc and .pyo files
753 # (idea by glen <at> pld-linux <dot> org)
754 %__spec_install_post_py_hardlink {\
755 %{!?no_install_post_py_hardlink: __spec_install_post_py_hardlink() { \
756 [ ! -d "$RPM_BUILD_ROOT" ] || find "$RPM_BUILD_ROOT" -name '*.pyc' | while read a; do \
757         b="${a%.pyc}.pyo"; \
758         if cmp -s "$a" "$b"; then \
759                 ln -f "$a" "$b"; \
760         fi; \
761 done \
762 }; __spec_install_post_py_hardlink } }
763
764 # remove python sources, so that check-files won't complain
765 # (idea by glen <at> pld-linux <dot> org)
766 %py_postclean() \
767 for d in %{py_sitescriptdir} %{py_sitedir} %*; do \
768  [ ! -d "$RPM_BUILD_ROOT$d" ] || find "$RPM_BUILD_ROOT$d" -name '*.py' -print0 | xargs -0r -l512 rm;\
769 done \
770 %{nil}
771
772 # depmod macro
773 %depmod() { \
774 umask 022; \
775 if [ -e /boot/System.map-%1 ]; then \
776         /sbin/depmod -a -F /boot/System.map-%1 %1; \
777 else \
778         if [ -e /boot/System.map ]; then \
779                 /sbin/depmod -a -F /boot/System.map %1; \
780         else \
781                 /sbin/depmod -a %1; \
782         fi \
783 fi; \
784 }
785
786 # XMMS specific macros
787 %xmms_prefix                    %{expand:%%global xmms_prefix %(xmms-config --prefix 2>/dev/null || echo ERROR)}%xmms_prefix
788 %xmms_exec_prefix               %{expand:%%global xmms_exec_prefix %(xmms-config --exec-prefix 2>/dev/null || echo ERROR)}%xmms_exec_prefix
789 %xmms_version                   %{expand:%%global xmms_version %(xmms-config --version 2>/dev/null || echo ERROR)}%xmms_version
790 %xmms_datadir                   %{expand:%%global xmms_datadir %(xmms-config --data-dir 2>/dev/null || echo ERROR)}%xmms_datadir
791 %xmms_plugindir                 %{expand:%%global xmms_plugindir %(xmms-config --plugin-dir 2>/dev/null || echo ERROR)}%xmms_plugindir
792 %xmms_visualization_plugindir   %{expand:%%global xmms_visualization_plugindir %(xmms-config --visualization-plugin-dir 2>/dev/null || echo ERROR)}%xmms_visualization_plugindir
793 %xmms_input_plugindir           %{expand:%%global xmms_input_plugindir %(xmms-config --input-plugin-dir 2>/dev/null || echo ERROR)}%xmms_input_plugindir
794 %xmms_output_plugindir          %{expand:%%global xmms_output_plugindir %(xmms-config --output-plugin-dir 2>/dev/null || echo ERROR)}%xmms_output_plugindir
795 %xmms_effect_plugindir          %{expand:%%global xmms_effect_plugindir %(xmms-config --effect-plugin-dir 2>/dev/null || echo ERROR)}%xmms_effect_plugindir
796 %xmms_general_plugindir         %{expand:%%global xmms_general_plugindir %(xmms-config --general-plugin-dir 2>/dev/null || echo ERROR)}%xmms_general_plugindir
797
798 %_target_base_arch      %{expand:%%global _target_base_arch %(echo %{_target_cpu} | sed 's/i.86/i386/;s/athlon/i386/;s/pentium./i386/;s/amd64/x86_64/;s/ia32e/x86_64/')}%_target_base_arch
799
800 # user/group checking macros
801 #
802 # Usage:
803 #       %userremove myuser
804 #
805 %userremove     /usr/lib/rpm/user_group.sh user del
806 %groupremove    /usr/lib/rpm/user_group.sh group del
807 #
808 # Usage:
809 #       if %usertestrm myuser; then
810 #               /usr/sbin/userdel -r myuser
811 # Note:
812 #       use these macros only if you need to call userdel/groupdel with
813 #       a non-standard option or take an extra action; otherwise use the
814 #       %userremove/%groupremove macros
815 #
816 %usertestrm     /usr/lib/rpm/user_group.sh user testrm
817 %grouptestrm    /usr/lib/rpm/user_group.sh group testrm
818 # user group membership management macros
819 #
820 # Usage:
821 #       %addusertogroup myuser agroup
822 #
823 %addusertogroup /usr/lib/rpm/user_group.sh user addtogroup
824
825 # banner support (useful in {pre,post}{,un} and triggers)
826 #
827 # Usage:
828 #       %banner name [-a] [-e] [-n] [-tn] <<EOF
829 # the banner text, the banner text
830 # the banner text, and following line
831 #EOF
832 # You can use any form of here-document, <<'EOF' <<-EOT will do.
833 # NOTE: if your use "<<-EOF", then You can actually indent inside here-document.
834 #
835 # -a   - append to the banner
836 # -e   - send to stderr instead of stdout
837 # -n   - no show banner (overrides -t)
838 # -t   - show only, if RPM_SCRIPTVERBOSITY >= n; default n=5
839 #
840 # Tests:
841 # (rpm -E '%banner -e banner <<EOF'; echo -e 'hi\nEOF') > m; sh -x m
842 # rpm -E 'date | %banner -e banner' > m; sh -x m
843 #
844 %banner(aent:) ( \
845 RPM_SCRIPTVERBOSITY=5 \
846 [ -r /etc/sysconfig/rpm ] && . /etc/sysconfig/rpm \
847 if [ -x /usr/bin/banner.sh ]; then \
848         CMD="/usr/bin/banner.sh %{-e:--stderr} %{!-n:$([ $RPM_SCRIPTVERBOSITY -ge %{-t:%{-t*}}%{!-t:5} ] && echo -s)} %{!-a:-m}%{-a:-M} %1" \
849 else \
850         CMD="cat%{-e: >&2}" \
851 fi \
852 eval $CMD %{?2:%2}%{?3: %3}) \
853 %{nil}
854
855 # useradd/groupadd macros
856 # Author: Elan Ruusamäe <glen@pld-linux.org>
857 #
858 # Usage:
859 #   %useradd [-P package] [-u uid] [-d home_dir] [-s shell] [-c comment]
860 #   [-g initial_group] [-G group[,...]] login
861 #
862 #  -u uid. REQUIRED
863 #  -g gid/group. REQUIRED
864 #  -s defaults to /bin/false
865 #  -d defaults to /usr/share/empty
866 #  -c No default
867 #  -r is accepted but ignored (it's always set)
868 #  -k skeleton dir. defaults to /usr/share/empty
869 # rpm specific flags
870 #  -P package name. defaults to %{name}
871 #
872 %useradd(c:d:e:f:g:G:Mmk:op:s:u:rP:) \
873 %{!-u:%{error:useradd: Required argument -u missing}} \
874 %{!-g:%{error:useradd: Required argument -g missing}} \
875 %{!?1:%{error:useradd: Required parameter login missing}} \
876 if [ -n "`/bin/id -u %{expand:%{%{#}}} 2>/dev/null`" ]; then \
877         if [ "`/bin/id -u %{expand:%{%{#}}}`" != "%{-u*}" ]; then \
878                 echo "Error: user %{expand:%{%{#}}} doesn't have uid=%{-u*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
879                 exit 1 \
880         fi \
881 else \
882         echo "Adding user %{expand:%{%{#}}} UID=%{-u*}." \
883         /usr/sbin/useradd \\\
884                 %{-m:-m -k %{-k*}%{!-k:/usr/share/empty}} \\\
885                 -u %{-u*} \\\
886                 -r \\\
887                 -d %{-d*}%{!-d:/usr/share/empty} \\\
888                 -s %{-s*}%{!-s:/bin/false} \\\
889                 %{-c:-c "%(set -- %{-c*} %{*}; echo $1)"}\\\
890                 -g %{-g*} \\\
891                 %{-M} \\\
892                 %{-G:-G %{-G*}} \\\
893                 %{expand:%{%{#}}} 1>&2 || exit $? \
894         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i passwd || : \
895 fi;
896
897 # Usage:
898 #   %groupadd [-P package] [-g gid] group
899 #
900 # -g gid. REQUIRED
901 #
902 # Sample:
903 #   %groupadd -P %{name}-base -g %{gid} %{name}
904
905 %groupadd(g:P:rfo)      \
906 %{!-g:%{error:groupadd: Required argument -g missing}} \
907 %{!?1:%{error:groupadd: Required parameter group missing}} \
908 if [ -n "`/usr/bin/getgid %{1}`" ]; then \
909         if [ "`/usr/bin/getgid %{1}`" != "%{-g*}" ]; then \
910                 echo "Error: group %{1} doesn't have gid=%{-g*}. Correct this before installing %{-P*}%{!?-P:%{name}}." 1>&2 \
911                 exit 1 \
912         fi \
913 else \
914         echo "Adding group %{1} GID=%{-g*}." \
915         /usr/sbin/groupadd -g %{-g*} -r %{1} 1>&2 || exit $? \
916         [ ! -x /usr/sbin/nscd ] || /usr/sbin/nscd -i group || : \
917 fi;
918
919 # webapp macros
920 # Author: Elan Ruusamäe <glen@pld-linux.org>
921 #
922 # The config is installed/removed inside trigger, this means that you can any
923 # time install apache1/apache/lighttpd package and the configuration file is
924 # updated. if you don't need the config for various reason for specific
925 # webserver, just remove the symlink from config directory using webapp
926 # program. the trigger will not recreate the symlink on upgrades. In other
927 # words the config is linked to webserver config directory on first install of
928 # PACKAGE or WEBSERVER.
929 #
930 # Add package's webserver config to webserver webapps dir.
931 # Usage:
932 #   %webapp_register WEBSERVER WEBAPP
933 #
934 %webapp_register() \
935 %{?debug:set -x; echo "webapp_register: %{name}-%{version}-%{release} 1:[$1]; 2:[$2]"} \
936 if [ "$1" = "1" ] && [ "$2" = "1" ]; then\
937         /usr/sbin/webapp register %1 %2\
938 fi\
939 # reload webserver if the config symlink is there and skip reload if webserver is upgraded\
940 if [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ] && [ "$2" -lt "2" ]; then\
941         %{expand:%service -q %%1 reload}\
942 fi\
943 %{nil}
944
945 # Remove package's config from webserver webapps dir.
946 # Usage:
947 #   %webapp_register [-f] WEBSERVER WEBAPP
948 %webapp_unregister(f) \
949 %{?debug:set -x; echo "webapp_unregister: %{name}-%{version}-%{release}: 1:[$1]; 2:[$2]"} \
950 # remove link if either of the packages are gone \
951 if [ -n "%{-f:1}" ] || [ "$1" = "0" ] || [ "$2" = "0" ] && [ -L /etc/%1/webapps.d/%(echo "%2" | tr '/' '-').conf ]; then \
952         /usr/sbin/webapp unregister %1 %2\
953         %{expand:%service -q %%1 reload}\
954 fi \
955 %{nil}
956
957 # service macro.
958 # Author: Elan Ruusamäe <glen@pld-linux.org>
959 #
960 # calls usual service restart on package %post, but skips the restart if
961 # administrator has disabled automatic service restarts in either global
962 # /etc/sysconfig/rpm or per service /etc/sysconfig/SERVICE file.
963 #
964 # Usage:
965 #   %service [-q] [-n] SERVICE ACTION ["SERVICE NICE DESCRIPTION"]
966 #
967 #  -q be silent when service isn't started (for scriplets restaring other package's services)
968 #  -n NOOP mode, do not actually restart service
969 #
970 # Requirements:
971 # BuildRequires:        rpmbuild(macros) >= 1.268
972 # Requires:     rc-scripts
973 # -n option:
974 # BuildRequires:        rpmbuild(macros) >= 1.450
975 %service(qn) {{%(export noop=%{-n:1} quiet=%{-q:1}; /usr/lib/rpm/service_generator.sh %{*}) };}
976
977
978 # Java macros. based on jpackage macros.java
979 #
980 # Root directory where all Java VMs/SDK/JREs are installed.
981 %_jvmdir                %{_libdir}/jvm
982
983 # Root directory where all Java VMs/SDK/JREs expose their jars
984 %_jvmjardir             %{_libdir}/jvm-exports
985
986 # Root directory for all Java VM/SDK/JRE's private things.
987 %_jvmprivdir    %{_libdir}/jvm-private
988
989 # Root directory for all architecture dependent parts of Java VM/SDK/JRE's
990 %_jvmlibdir             %{_libdir}/jvm
991
992 # Root directory for all architecture independent parts of Java VM/SDK/JRE's
993 %_jvmdatadir    %{_datadir}/jvm
994
995 # Root directory for all configurations parts of Java VM/SDK/JRE's
996 %_jvmsysconfdir %{_sysconfdir}/jvm
997
998 # Root directory for all common architecture dependent parts of Java VM/SDK/JRE's
999 %_jvmcommonlibdir       %{_libdir}/jvm-common
1000
1001 # Root directory for all common architecture independent parts of Java VM/SDK/JRE's
1002 %_jvmcommondatadir      %{_datadir}/jvm-common
1003
1004 # Root directory for all common configurations parts of Java VM/SDK/JRE's
1005 %_jvmcommonsysconfdir   %{_sysconfdir}/jvm-common
1006
1007 # Directory where arch-specific (JNI) version-independent jars are installed.
1008 %_jnidir                %{_libdir}/java
1009
1010 %java_home              %{expand:%%global java_home %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVA_HOME; . %{_javadir}-utils/java-functions; set_jvm; echo ${JAVA_HOME:-ERROR})}%java_home
1011
1012 %ant                    JAVA_HOME=%{java_home} ant
1013 %jar                    %{java_home}/bin/jar
1014 %java                   %{expand:%%global java %([ -f %{_javadir}-utils/java-functions ] || { echo ERROR; exit 0; }; unset JAVACMD; . %{_javadir}-utils/java-functions; set_javacmd; echo $JAVACMD)}%java
1015 %javac                  %{java_home}/bin/javac
1016 %javadoc                %{java_home}/bin/javadoc
1017
1018 %add_jvm_extension      JAVA_LIBDIR=%{buildroot}/%{_javadir}    %{_bindir}/jvmjar -l
1019
1020 %jpackage_script() \
1021 install -d $RPM_BUILD_ROOT%{_bindir}\
1022 cat > $RPM_BUILD_ROOT%{_bindir}/%5 << 'EOF' \
1023 #!/bin/sh\
1024 #\
1025 # %{name} script\
1026 # JPackage Project <http://www.jpackage.org/>\
1027 \
1028 # Source functions library\
1029 . %{_javadir}-utils/java-functions\
1030 \
1031 # Source system prefs\
1032 if [ -f %{_sysconfdir}/java/%{name}.conf ]; then\
1033     . %{_sysconfdir}/java/%{name}.conf\
1034 fi\
1035 \
1036 # Source user prefs\
1037 if [ -f $HOME/.%{name}rc ]; then\
1038     . $HOME/.%{name}rc\
1039 fi\
1040 \
1041 # Configuration\
1042 MAIN_CLASS=%1\
1043 BASE_FLAGS=%2\
1044 BASE_OPTIONS=%3\
1045 BASE_JARS="%(echo %4 | tr ':' ' ')"\
1046 \
1047 # Set parameters\
1048 set_jvm\
1049 set_classpath $BASE_JARS\
1050 set_flags $BASE_FLAGS\
1051 set_options $BASE_OPTIONS\
1052 \
1053 # Let's start\
1054 run "$@"\
1055 EOF
1056
1057 # jpackage 1.7
1058 # Directory for maven depmaps
1059 #
1060 %_mavendepmapdir /etc/maven
1061 %_mavendepmapfragdir /etc/maven/fragments
1062
1063 #
1064 # add_to_depmap adds an entry to the depmap. The arguments are:
1065 #
1066 # %1 the original groupid
1067 # %2 the original artifact id
1068 # %3 the version
1069 # %4 the new groupid
1070 # %5 the new artifactid
1071 #
1072
1073 %add_to_maven_depmap() \
1074 install -dm 755 $RPM_BUILD_ROOT/%{_mavendepmapfragdir}\
1075 cat >>$RPM_BUILD_ROOT/%{_mavendepmapfragdir}/%{name}<< EOF\
1076 <dependency>\
1077     <maven>\
1078         <groupId>%1</groupId>\
1079         <artifactId>%2</artifactId>\
1080         <version>%3</version>\
1081     </maven>\
1082     <jpp>\
1083         <groupId>%4</groupId>\
1084         <artifactId>%5</artifactId>\
1085         <version>%3</version>\
1086     </jpp>\
1087 </dependency>\
1088 \
1089 EOF\
1090 %{nil}
1091
1092 #==============================================================================
1093 #
1094 # update_maven_depmap updates the main maven depmap
1095 #
1096 %update_maven_depmap() \
1097 echo -e "<dependencies>\\n" > %{_mavendepmapdir}/maven2-depmap.xml\
1098 if [ -d %{_mavendepmapfragdir} ] && [ -n "`find %{_mavendepmapfragdir} -type f`" ]; then\
1099 cat %{_mavendepmapfragdir}/* >> %{_mavendepmapdir}/maven2-depmap.xml\
1100 fi\
1101 echo -e "</dependencies>\\n" >> %{_mavendepmapdir}/maven2-depmap.xml
1102
1103
1104 # PEAR install macros
1105 # Author: Elan Ruusamäe <glen@pld-linux.org>
1106 #
1107 # Usage:
1108 #       %%pear_package_setup [-a #] [-n FMT]
1109 #
1110 # -a #   - also unpack SOURCE#. for PEAR bootstrapping
1111 # -n FMT - create builddir with FMT, instead of default %%{_pearname}-%%{version}
1112 # -z     - unpack pear package and let pear use package.xml (not tarball) for install. for PEAR bootstrapping
1113 #
1114 # unpack PEAR package to %%{_builddir}/FMT. package is extracted with already
1115 # destination hierarchy. you should copy the tree to buildroot after
1116 # patching/reorganizing with %%pear_package_install.
1117 #
1118 # additionally BUILDROOT is stripped from files and files are converted to UNIX
1119 # line endings.
1120 #
1121 # the pear install process output is recorded to install.log, you should put it
1122 # to %%doc for later debug or just for information.
1123 #
1124 # additionally additional-packages.txt is produced if it was detected that the
1125 # package has optional dependencies. the file format is suitable of displaying
1126 # in %%post of a package. you should put this file to %%doc. noautocompressdoc is
1127 # automatically added for this file.
1128
1129
1130 # records install.log and transforms PEAR names to PLD Linux rpm package names.
1131 %__pear_install_log \
1132 tee install.log \
1133 # make post message of optional packages \
1134 grep 'can optionally use' install.log | sed -e 's,package "pear/,package "php-pear-,g;s,^pear/,php-pear-,' > optional-packages.txt \
1135 if [ -s optional-packages.txt ]; then \
1136         awk -F'"' '/use package/{print $2}' optional-packages.txt | sed -e "s,_,/,g;s,php-pear-, 'pear(,;s,$,.*)'," | tr -d '\\\n' > _noautoreq \
1137 else \
1138         rm -f optional-packages.txt \
1139 fi \
1140 %{nil}
1141
1142 # command invoking pear cli
1143 %__pear /usr/bin/pear
1144
1145 %pear_install(a:n:zD) \
1146 %__pear \\\
1147         -c pearrc \\\
1148         -d doc_dir=/docs \\\
1149         -d php_dir=%{php_pear_dir} \\\
1150         -d bin_dir=%{_bindir} \\\
1151         -d data_dir=%{php_pear_dir}/data \\\
1152         -d test_dir=%{php_pear_dir}/tests \\\
1153         install \\\
1154         --packagingroot=%{builddir} \\\
1155         --offline \\\
1156         --nodeps \\\
1157         %{-f:--force} \\\
1158         %{!-z:%{S:%{-a*}%{!-a:0}}}%{-z:$_P} > .install.log || { c=$?; cat .install.log; exit $c; }; \
1159 %{nil}
1160
1161 # The main macro.
1162 # using this macro will append optional-packages.txt to the nocompressdoc list
1163 # as it's displayed to user after package install. and adding additional gzip
1164 # dep is just waste ;)
1165 %pear_package_setup(a:n:zD) \
1166 %define srcdir %{-n*}%{!-n:%{_pearname}-%{version}} \
1167 %define builddir %{_builddir}/%{srcdir} \
1168 %setup -q -c -T %{-D:-D} -n %{srcdir} \
1169 %{-z:tar zxf %{S:0}; %{-a:tar zxf %{S:%{-a*}}}} \
1170 %{-z:_P=package2.xml; [ -f $_P ] || _P=package.xml; _N=%{srcdir}; mv $_P $_N; cd $_N} \
1171 %pear_install \
1172 %{-z:cd ..} \
1173 cat %{-z:$_N/}.install.log | %__pear_install_log \
1174 \
1175 # undos sources \
1176 find -type f -print0 | xargs -0 sed -i -e 's,\\r$,,' \
1177 %{!?_noautocompressdoc:%global _noautocompressdoc %{nil}}%{expand:%%global _noautocompressdoc %{_noautocompressdoc} optional-packages.txt} \
1178 %{!?_noautoprov:%global _noautoprov %{nil}}%{expand:%%global _noautoprov %{_noautoprov} 'pear(tests/.*)'} \
1179 %{nil}
1180
1181 # Copies exctracted PEAR package structure and PEAR registry to buildroot.
1182 # Author: Elan Ruusamäe <glen@pld-linux.org>
1183 %pear_package_install() \
1184 cp -a ./%{php_pear_dir}/{.registry,*} $RPM_BUILD_ROOT%{php_pear_dir} \
1185 find $RPM_BUILD_ROOT%{php_pear_dir} '(' -name '*~' -o -name '*.orig' ')' | xargs -r rm -v \
1186 # help the developer out a little: \
1187 if [ -f _noautoreq ]; then \
1188         echo "AutoReqdep detected:" \
1189         echo "_noautoreq $(cat _noautoreq)" \
1190 fi \
1191 %{nil}
1192
1193
1194 # Register OpenLDAP schema.
1195 # Author: Elan Ruusamäe <glen@pld-linux.org>
1196 #
1197 # Usage:
1198 #   %%openldap_schema_register [-d core,nis] %{schemadir}/horde.schema
1199 #
1200 #  -d specify dependant schemas, separated by comma
1201 #
1202 %openldap_schema_register(d:) \
1203 for schema in %*; do \
1204         if ! grep -q "$schema" /etc/openldap/slapd.conf; then \
1205                 %{__sed} -i -e " \
1206                         /^include.*local.schema/{ \
1207                                 iinclude\\t     $schema\
1208                         } \
1209                 " /etc/openldap/slapd.conf \
1210         fi \
1211 done \
1212 # enable dependant schemas \
1213 if [ "%{-d*}" ]; then \
1214         %{__sed} -i -e ' \
1215         /^#include.*\\(%(echo '%{-d*}' | %{__sed} -e 's/,/\\\\|/g')\\)\\.schema/{ \
1216                 s/^#// \
1217         }' /etc/openldap/slapd.conf \
1218 fi \
1219 %{nil}
1220
1221 # Unregister OpenLDAP schema.
1222 # Author: Elan Ruusamäe <glen@pld-linux.org>
1223 #
1224 # Usage:
1225 #   %%openldap_schema_unregister %{schemadir}/horde.schema
1226 #
1227 %openldap_schema_unregister() \
1228 for schema in %*; do \
1229         if grep -q "$schema" /etc/openldap/slapd.conf; then \
1230                 %{__sed} -i -e " \
1231                 /^include.*$(echo "$schema" | %{__sed} -e 's,/,\\\\/,g')/d \
1232                 # for symmetry it would be nice if we disable enabled schemas in post, \
1233                 # but we really can not do that, it would break something else. \
1234                 " /etc/openldap/slapd.conf \
1235         fi \
1236 done \
1237 %{nil}
1238
1239 %env_update [ ! -x /sbin/env-update ] || /sbin/env-update -u || :
1240
1241
1242 # Build modules for kernels 2.6
1243 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1244 #
1245 # Usage:
1246 #       %build_kernel_modules -m <modules> -C <directory>
1247 #
1248 #  remember that proper Makefile is still required
1249 # Options:
1250 #  -m <modules> (required) -- comma-separated list of modules to save,
1251 #               without .ko extension, may be placed in subdirectory
1252 #  -C <directory> -- change to <directory> before doing anything
1253 #  -p <arg>, -P <arg> -- arguments passeed to make scripts
1254 #  -c -- do not execute make clean
1255 #  <additional arguments> -- all additional arguments will be passed to
1256 #               make modules
1257 #
1258 # Additional patching supported via here document. Try:
1259 #       %build_kernel_modules -m module <<'EOF'
1260 #       your patch script here
1261 #       EOF
1262 # Don't use it unless patching depends on config options.
1263
1264 # Developer note: don't touch it unless you know how to handle '\'.
1265 # - \ in script expands to nothing
1266 # - \\\ in script expands to \
1267 # - \\\ inside definition expands to nothing
1268 # - \\\\\\\ inside definition expands to \
1269 # - in last line \ has to touch arguments so arguments passing
1270 #   in new lines (using \) will be supported
1271
1272 %build_kernel_modules(p:P:m:C:c)                                                                        \
1273 %{!?-m:%{error:%{0}: Required module name/list missing} exit 1}         \
1274                                                                                                                                         \
1275 %define Opts                                                                                                            \\\\\\\
1276 %if "%{_target_base_arch}" != "%{_arch}"                                                        \\\
1277         %if "%{_arch}" == "x86_64" && "%{_target_base_arch}" == "i386"  \\\
1278         CC="%{kgcc}" ARCH=%{_target_base_arch}                                                  \\\
1279         %else                                                                                                                   \\\
1280         ARCH=%{_target_base_arch} CROSS_COMPILE=%{_target_cpu}-pld-linux- \\\
1281         %endif                                                                                                                  \\\
1282 %else                                                                                                                           \\\
1283         CC="%{kgcc}"                                                                                                    \\\
1284 %endif                                                                                                                          \
1285 %define MakeOpts HOSTCC="%{kgcc}" SYSSRC=%{_kernelsrcdir} SYSOUT=$PWD/o \\\\\\\
1286                 O=$PWD/o %{?with_verbose:V=1} %{Opts}                                           \
1287                                                                                                                                         \
1288 %{?-C:cd %{-C*}}                                                                                                        \
1289 compile() {                                                                                                                     \
1290         local L="<" PATCH_SH;                                                                                   \
1291         [[ '%{*}' != *$L$L* ]] || PATCH_SH="set -x -e;$(cat)"                   \
1292         set -e -x                                                                                                               \
1293         local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1294                                                                                                                                         \
1295 for cfg in ${cfgs:-dist}; do                                        \
1296         [ -r "%{_kernelsrcdir}/config-$cfg" ] || exit 1                                 \
1297                                                                                                                                         \
1298         rm -rf o                                                                                                                \
1299         install -d o/include/linux                                                                              \
1300         ln -sf %{_kernelsrcdir}/config-$cfg o/.config                                   \
1301         ln -sf %{_kernelsrcdir}/Module.symvers-$cfg o/Module.symvers    \
1302         ln -sf %{_kernelsrcdir}/include/linux/autoconf-$cfg.h o/include/linux/autoconf.h \
1303                                                                                                                                         \
1304         set +x                                                                                                                  \
1305         [ -z "$PATCH_SH" ] || echo "$PATCH_SH" | %__spec_build_shell    \
1306         set -x                                                                                                                  \
1307                                                                                                                                         \
1308         %if %{with dist_kernel}                                                                                 \
1309                 %{__make} -j1 -C %{_kernelsrcdir} prepare scripts                       \\\
1310                         %{-p*} %{-P*}                                                                                   \\\
1311                         %{MakeOpts}                                                                                             \
1312         %else                                                                                                                   \
1313                 install -d o/include/config                                                                     \
1314                 touch o/include/config/MARKER                                                           \
1315                 ln -sf %{_kernelsrcdir}/scripts o/scripts                                       \
1316         %endif                                                                                                                  \
1317                                                                                                                                         \
1318         %{!?-c:%{__make} -C %{_kernelsrcdir} clean                                              \\\
1319                 RCS_FIND_IGNORE="-name '*.ko' -o"                                                       \\\
1320                 ${1+"$@"}                                                                                                       \\\
1321                 M=$PWD %{MakeOpts}}                                                                                     \
1322                                                                                                                                         \
1323         %{__make} -C %{_kernelsrcdir} modules                                                   \\\
1324                 ${1+"$@"}                                                                                                       \\\
1325                 M=$PWD %{MakeOpts}                                                                                      \
1326                                                                                                                                         \
1327         for MODULE in {%{-m*},}; do                                                                             \
1328                 [ -z "${MODULE}" ] || mv ${MODULE}{,-$cfg}.ko                           \
1329         done                                                                                                                    \
1330 done                                                                                                                            \
1331 %{?-C:cd -}                                                                                                                     \
1332 }                                                                                                                                       \
1333 compile %{*}\
1334 %{nil}
1335
1336
1337 # Install kernel modules built by %build_kernel_modules
1338 # Author: Przemyslaw Iskra <sparky@pld-linux.org>
1339 #
1340 # Usage:
1341 #       %install_kernel_modules -m <modules> -d <directory>
1342 #
1343 # Options:
1344 #  -m <modules> (required) -- comma-separated list of modules to install,
1345 #               without .ko extension, may be placed in subdirectory
1346 #  -d <directory> (required) -- in what subdirectory modules should be
1347 #               installed (eg. misc, kernel/drivers/net)
1348 #  -s <suffix> -- suffix to use when installing modules, useful when module
1349 #               with same name exists in kernel already
1350 #  -n <file> -- name of modprobe config file to use (without .conf extension)
1351 #               for defining aliases, only useful with -s
1352
1353 %install_kernel_modules(m:d:s:n:)                                                                       \
1354 %{!?-m:%{error:%{0}: Required module name (-m) missing}exit 1}          \
1355 %{!?-d:%{error:%{0}: Required module directory missing}exit 1}          \
1356 %{?-n:%{!?-s:%{error:%{0}: Modprobe .conf file requires module suffix}exit 1}} \
1357                                                                                                                                         \
1358 %define KernelD $RPM_BUILD_ROOT/lib/modules/%{_kernel_ver}                      \
1359 %define ModprobeD $RPM_BUILD_ROOT%{_sysconfdir}/modprobe.d/%{_kernel_ver} \
1360                                                                                                                                         \
1361 local cfgs='%{?with_dist_kernel:%{?with_smp: smp}%{?with_up: up}}%{!?with_dist_kernel: nondist}' \
1362                                                                                                                                         \
1363 for MODULE in {%{-m*},}; do                                                                                     \
1364         [ -n "${MODULE}" ] || continue                                                                  \
1365         for cfg in ${cfgs:-dist}; do                                    \
1366                 [ "$cfg" = smp ] && suf=smp || suf=                                                     \
1367                 MNAME=${MODULE##*/}                                                                                     \
1368                 install -D ${MODULE}-$cfg.ko                                                            \\\
1369                         %{KernelD}$suf/%{-d*}/${MNAME}%{-s:-%{-s*}}.ko                  \
1370                 %{?-s:install -d %{ModprobeD}$suf                                                       \
1371                         echo "alias ${MNAME} ${MNAME}-%{-s*}"                                   \\\
1372                         >> %{ModprobeD}$suf/%{-n*}.conf}                                                \
1373         done                                                                                                                    \
1374 done                                                                                                                            \
1375 %{nil}
1376
1377 # patchset macros
1378 # Author: Elan Ruusamäe <glen@pld-linux.org>
1379 #
1380 # Usage:
1381 #   %patchset_source -f <seq(1) format> <start> [<end>]
1382 #   %patchset_patch <start> [<end>]
1383 #
1384 # If <end> is omited, it is assumed to be <start>.
1385 #
1386 # For example in preamble:
1387 #  %patchset_source -f ftp://ftp.vim.org/pub/editors/vim/patches/7.0/7.0.%03g 33 44
1388 # and in %prep:
1389 #  %patchset_patch 33 44
1390
1391 # generate SourceX urls from range START STOP
1392 # Format can be SINGLE format char of %e, %f, %g, see seq(1)
1393 # The sources start from 10000
1394 %patchset_source(f:b:) %(
1395         base=%{-b*}%{!-b*:10000};
1396         start=$(expr $base + %1);
1397         end=$(expr $base + %{?2}%{!?2:%{1}});
1398         # we need to call seq twice as it doesn't allow two formats
1399         seq -f 'Patch%g:' $start $end > %{tmpdir}/__ps1;
1400         seq -f '%{-f*}' %1 %{?2}%{!?2:%{1}} > %{tmpdir}/__ps2;
1401         paste %{tmpdir}/__ps{1,2};
1402         rm -f %{tmpdir}/__ps{1,2};
1403 ) \
1404 %{nil}
1405
1406 # apply sources from %patchset_source
1407 # -p specify -pX for %patch line
1408 # -b base offset: defaults to 10000
1409 %patchset_patch(f:p:b:) %(
1410         base=%{-b*}%{!-b*:10000};
1411         start=$(expr $base + %1);
1412         end=$(expr $base + %{?2}%{!?2:%{1}});
1413         echo ": patchset_patch %1%{?2: to %2}";
1414         seq -f 'patch%g %{-p*:-p%{-p*}}' $start $end | sed -e s,^,%%,;
1415 ) \
1416 %{nil}
1417
1418 # browser plugins v2
1419 # Author: Elan Ruusamäe <glen@pld-linux.org>
1420 #
1421 # Usage:
1422 #       %browser_plugins_add_browser <name> -p <plugindir>
1423 #
1424 #  <name> (required) -- name of the browser. usually %{name}.
1425 #  -p <plugindir> (required) -- in what directory browser searches for its plugins.
1426 #  -b -- default blacklists
1427 #  -a <arch> override arch
1428 #
1429 # Example:
1430 #   %browser_plugins_add_browser %{name} -p %{_firefoxdir}/plugins
1431
1432 %_browserpluginsconfdir         /etc/browser-plugins
1433 %_browserpluginsdir                     %{_libdir}/browser-plugins
1434 %update_browser_plugins         /usr/sbin/update-browser-plugins || :
1435
1436 %browser_plugins_add_browser(p:b:a:) \
1437         browser=%1.%{!-a:%{_target_base_arch}}%{-a*} \
1438         install -d $RPM_BUILD_ROOT%{_browserpluginsconfdir}/{blacklist,browsers}.d \
1439         ln -s %{-p*} $RPM_BUILD_ROOT%{_browserpluginsconfdir}/browsers.d/$browser \
1440         blacklist_file=$RPM_BUILD_ROOT%{_browserpluginsconfdir}/blacklist.d/$browser.blacklist \
1441         echo '# This file format is shell globs at base dir of plugindir' > $blacklist_file \
1442         %{-b:cat >> $blacklist_file %{-b*}} \
1443 %{nil}
1444
1445 # Helper for LUA.
1446 # split string separated by space into quoted list
1447 #
1448 # Author: Elan Ruusamäe <glen@pld-linux.org>
1449 #
1450 # %__lua_split /bin/sh /bin/pdksh -> "/bin/sh", "/bin/pdksh"
1451 %__lua_split() %(echo "%*" | awk '{for (i=1;i<=NF;i++) printf("\\"%%s\\"%%s", $i, i == NF ? "" : ", ")}')
1452
1453 # adjust /etc/shells by adding and removing shells from there
1454 # Author: Elan Ruusamäe <glen@pld-linux.org>
1455 #
1456 # Usage:
1457 #   %post       -p <lua>
1458 #   %lua_add_etc_shells /bin/sh /bin/pdksh
1459 #
1460 #   %preun      -p <lua>
1461 #   if arg[2] == 0 then
1462 #       %lua_remove_etc_shells /bin/bash /bin/rbash
1463 #   end
1464 #
1465 # Requirements:
1466 # BuildRequires:        rpmbuild(macros) >= 1.462
1467 #
1468
1469 %lua_add_etc_shells() \
1470 t = {}\
1471 f = io.open("/etc/shells", "r")\
1472 if f then\
1473         for l in f:lines() do t[l]=l; end\
1474         f:close()\
1475 end\
1476 for _, s in ipairs({%{expand:%%__lua_split %*}}) do\
1477         if not t[s] then\
1478                 print("Adding "..s.." to /etc/shells")\
1479                 f = io.open("/etc/shells", "a"); f:write(s.."\\n"); f:close()\
1480         end\
1481 end\
1482 %{nil}
1483
1484 %lua_remove_etc_shells() \
1485 t = {}\
1486 f = io.open("/etc/shells", "r")\
1487 if f then\
1488         for l in f:lines() do t[l]=l; end\
1489         f:close()\
1490 end\
1491 for _, l in pairs({%{expand:%%__lua_split %*}}) do\
1492         print("Removing "..l.." from /etc/shells")\
1493         t[l] = nil\
1494 end\
1495 s=""\
1496 for _, l in pairs(t) do\
1497         s=s..l.."\\n"\
1498 end\
1499 io.open("/etc/shells", "w"):write(s)\
1500 %{nil}
1501
1502 # Backwards compat. Use of %lua_ prefixed macros is preferred as these are cleaner to read.
1503 #
1504 # Author: Elan Ruusamäe <glen@pld-linux.org>
1505 #
1506 # Usage:
1507 #   %post       -p %add_etc_shells -p /bin/sh /bin/pdksh
1508 #   %preun      -p %remove_etc_shells -p /bin/sh /bin/pdksh
1509 #
1510 #  -p (optional) -- specifies that result is embeded %post script (prepends <lua> as first line)
1511 #
1512 # Requirements:
1513 # BuildRequires:        rpmbuild(macros) >= 1.429
1514 #
1515 %add_etc_shells(p) %{-p:<lua>}\
1516 %{expand:%%lua_add_etc_shells %*}\
1517 %{nil}
1518
1519 %remove_etc_shells(p) %{-p:<lua>}\
1520 %{-p:if arg[2] == 0 then}\
1521 %{expand:%%lua_remove_etc_shells %*}\
1522 %{-p:end} \
1523 %{nil}
1524
1525 # Check syntax for Python files
1526 #
1527 # Author: Elan Ruusamäe <glen@pld-linux.org>
1528 # Author: Arkadiusz Miśkiewicz <arekm@pld-linux.org>
1529 #
1530 # Usage:
1531 #   %py_lint src
1532 #
1533 # Requirements:
1534 # BuildRequires:        python
1535 # BuildRequires:        rpmbuild(macros) >= 1.469
1536
1537 %py_lint() \
1538 __py_lint() { \
1539 find "$@" -type f -name '*.py' | python -c ' \
1540 import sys \
1541 import compiler \
1542 \
1543 err = 0\
1544 for f in sys.stdin: \
1545         fd = open(f.strip()) \
1546         c = fd.read() \
1547         fd.close() \
1548         try: \
1549                 compiler.parse(c) \
1550         except SyntaxError, e: \
1551                 print "py_lint: %s: %s" % (f.strip(), e) \
1552                 err = err + 1\
1553 \
1554 if err: \
1555         print >> sys.stderr, "\\npy_lint: ERROR: Syntax errors in %d files.\\n" % err \
1556         sys.exit(1) \
1557 else: \
1558         print >> sys.stderr,  "py_lint: Found no syntax errors." \
1559 ' \
1560 }; __py_lint %* \
1561 %{nil}
1562
1563 # vim:ts=4 sw=4 noet syn=spec
This page took 0.317763 seconds and 3 git commands to generate.